#include "Base64.h"
#include <iostream>

namespace coreutils {
   
   const std::string base64_chars = 
     "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
     "abcdefghijklmnopqrstuvwxyz"
     "0123456789+/";
      
   bool Base64::isBase64(unsigned char c) {
      return (isalnum(c) || (c == '+') || (c == '/'));
   }
   
   MString Base64::encode(ZString data) {

      data.push();
      data.reset();
      MString ret;
      int in_len = data.getLength();
      int i = 0;
      int j = 0;
      unsigned char char_array_3[3];
      unsigned char char_array_4[4];
      
      while (in_len--) {
	 
	 char_array_3[i++] = data.nextChar();
	 if (i == 3) {
	    
	    char_array_4[0] = (char_array_3[0] & 0xfc) >> 2;
	    char_array_4[1] = ((char_array_3[0] & 0x03) << 4) + ((char_array_3[1] & 0xf0) >> 4);
	    char_array_4[2] = ((char_array_3[1] & 0x0f) << 2) + ((char_array_3[2] & 0xc0) >> 6);
	    char_array_4[3] = char_array_3[2] & 0x3f;
	    
	    for(i = 0; (i <4) ; i++)
	      ret.write(base64_chars[char_array_4[i]]);
	    i = 0;
	 }	 
      }
      
      if (i) {
	 
	 for(j = i; j < 3; j++)
	   char_array_3[j] = '\0';
	 
	 char_array_4[0] = ( char_array_3[0] & 0xfc) >> 2;
	 char_array_4[1] = ((char_array_3[0] & 0x03) << 4) + ((char_array_3[1] & 0xf0) >> 4);
	 char_array_4[2] = ((char_array_3[1] & 0x0f) << 2) + ((char_array_3[2] & 0xc0) >> 6);
	 
	 for (j = 0; (j < i + 1); j++)
	   ret.write(base64_chars[char_array_4[j]]);
	 
	 while((i++ < 3))
	   ret.write('=');	 
      }
      data.pop();
      return ret;
   }
   
   MString Base64::decode(ZString b64data) {

      b64data.push();
      b64data.reset();
      int in_len = b64data.getLength();
      int i = 0;
      int j = 0;
      unsigned char char_array_4[4], char_array_3[3];
      MString ret;
      
      while (in_len-- && (b64data.getChar() != '=') && isBase64(b64data.getChar())) {
	 
	 char_array_4[i++] = b64data.nextChar();
	 if (i ==4) {
	    
	    for (i = 0; i <4; i++)
	      char_array_4[i] = base64_chars.find(char_array_4[i]);
	    
	    char_array_3[0] = ( char_array_4[0] << 2       ) + ((char_array_4[1] & 0x30) >> 4);
	    char_array_3[1] = ((char_array_4[1] & 0xf) << 4) + ((char_array_4[2] & 0x3c) >> 2);
	    char_array_3[2] = ((char_array_4[2] & 0x3) << 6) +   char_array_4[3];
	    
	    for (i = 0; (i < 3); i++)
	      ret.write(char_array_3[i]);
	    i = 0;
	 }
	 
      }
      
      if (i) {
	 
	 for (j = 0; j < i; j++)
	   char_array_4[j] = base64_chars.find(char_array_4[j]);
	 
	 char_array_3[0] = (char_array_4[0] << 2) + ((char_array_4[1] & 0x30) >> 4);
	 char_array_3[1] = ((char_array_4[1] & 0xf) << 4) + ((char_array_4[2] & 0x3c) >> 2);
	 
	 for (j = 0; (j < i - 1); j++)
	   ret.write(char_array_3[j]);
      }
      b64data.pop();
      return ret;
   }
   
}
